<?php
  $NUM_ASPECTS_SPECIAL = 8;

  $retrograde = $rx1;

  $extra_height_for_aspect_grid = 300;
  $extra_width_for_aspect_grid = 60;
  $y_top_margin = 0;

  $longitude = $_SESSION['nL1'];
  $hc = $_SESSION['nHC1'];
  $house_pos = $_SESSION['nH1'];

  $use_this_aspect = "11111111000000000000000000";     //aspects used, 1 = used, 0 - not used

  $longitude[LAST_PLANET + 1] = $hc[1];
  $longitude[LAST_PLANET + 2] = $hc[10];

  $Ascendant1 = $hc[1];
  $hc[13] = $hc[1];

  $copyright1 = "2021+ by Allen Edwall";
  $copyright2 = "www.astrowin.org";

// create the blank image
  $overall_size = 640;        //size of the wheel itself
  $im = @imagecreatetruecolor($overall_size + $extra_width_for_aspect_grid, $overall_size + $y_top_margin + $extra_height_for_aspect_grid) or die("Cannot initialize new GD image stream");

// specify the colors
  $black = imagecolorallocate($im, 0, 0, 0);
  $white = imagecolorallocate($im, 255, 255, 255);
  $red = imagecolorallocate($im, 255, 0, 0);
  $blue = imagecolorallocate($im, 0, 0, 255);
  $magenta = imagecolorallocate($im, 255, 0, 255);
  $light_yellow = imagecolorallocate($im, 255, 255, 232);
  $orange = imagecolorallocate($im, 255, 128, 64);
  $cyan = imagecolorallocate($im, 0, 255, 255);
  $green = imagecolorallocate($im, 0, 224, 0);
  $light_green = imagecolorallocate($im, 232, 255, 232);
  $another_green = imagecolorallocate($im, 0, 128, 0);
  $grey = imagecolorallocate($im, 142, 142, 142);
  $gray = imagecolorallocate($im, 204, 204, 109);
  $light_blue = imagecolorallocate($im, 240, 255, 255);
  $very_light_blue = imagecolorallocate($im, 217, 255, 255);

  $asp_color_special[0] = $blue;
  $asp_color_special[1] = $blue;            //conjunction
  $asp_color_special[2] = $red;             //opposition
  $asp_color_special[3] = $green;           //trine
  $asp_color_special[4] = $red;             //square
  $asp_color_special[5] = $blue;            //quincunx
  $asp_color_special[6] = $green;           //sextile
  $asp_color_special[7] = $magenta;
  $asp_color_special[8] = $magenta;
  $asp_color_special[9] = $magenta;
  $asp_color_special[10] = $magenta;
  $asp_color_special[11] = $magenta;
  $asp_color_special[12] = $magenta;
  $asp_color_special[13] = $magenta;
  $asp_color_special[14] = $magenta;
  $asp_color_special[15] = $magenta;
  $asp_color_special[16] = $magenta;
  $asp_color_special[17] = $magenta;
  $asp_color_special[18] = $magenta;
  $asp_color_special[19] = $magenta;
  $asp_color_special[20] = $magenta;
  $asp_color_special[21] = $magenta;
  $asp_color_special[22] = $magenta;
  $asp_color_special[23] = $magenta;
  $asp_color_special[24] = $magenta;

// specific colors
  $planet_color = $black;
  $deg_min_color = $black;
  $sign_color = $magenta;

  $size_of_rect = $overall_size;    // size of rectangle in which to draw the wheel
  $diameter = 520;            // diameter of circle drawn
  $outer_outer_diameter = 600;      // diameter of circle drawn
  $outer_diameter_distance = ($outer_outer_diameter - $diameter) / 2; // distance between outer-outer diameter and diameter

  $inner_diameter_offset = 91;      // diameter of inner circle drawn
  $inner_diameter_offset_2 = 91;    // diameter of nextmost inner circle drawn
  $dist_from_diameter1 = 32;      // distance inner planet glyph is from circumference of wheel

  $radius = $diameter / 2;        // radius of circle drawn
  $middle_radius = ($outer_outer_diameter + $diameter) / 4 - 0;   //the radius for the middle of the two outer circles

  $center_pt_x = $extra_width_for_aspect_grid - 10 + ($size_of_rect / 2);       // center of circle
  $center_pt_y = 5 + $y_top_margin + ($size_of_rect / 2);   // center of circle

  $last_planet_num = LAST_PLANET;
  if ($ubt1 == 1) { $last_planet_num = LAST_PLANET - 2; }

  $num_planets = $last_planet_num + 1;
  $spacing = 5;     // spacing between planet glyphs around wheel - this number is really one more than shown here

// ------------------------------------------

// create colored rectangle on blank image
  imagefilledrectangle($im, 0, 0, $size_of_rect + $extra_width_for_aspect_grid, $size_of_rect + $y_top_margin + $extra_height_for_aspect_grid, $white);

// MUST BE HERE - I DO NOT KNOW WHY - MAYBE TO PRIME THE PUMP
  imagettftext($im, 11, 0, 0, 0, $black, dirname(__FILE__) . '/arial.ttf', " ");


// ------------------------------------------

// draw the outer-outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $outer_outer_diameter, $outer_outer_diameter, $white);
  imageellipse($im, $center_pt_x, $center_pt_y, $outer_outer_diameter, $outer_outer_diameter, $black);

// draw the outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter, $diameter, $white);
  imageellipse($im, $center_pt_x, $center_pt_y, $diameter, $diameter, $grey); //was red


// draw the outer-outer border of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $light_green);  //13 Nov 2010


//shade the areas of complete signs, alternating colors - do not move this code from here
  for ($i = 0; $i <= 330; $i = $i + 30)
  {
    $angle = $i + sprintf("%.0f", $Ascendant1);

    if ($flag == True)
    {
      imagefilledarc($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $angle, $angle + 30, $light_green, IMG_ARC_PIE);  //13 Nov 2010
    }
    else
    {
      imagefilledarc($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 1, $diameter - ($inner_diameter_offset * 2) - 1, $angle, $angle + 30, $light_green, IMG_ARC_PIE);  //13 Nov 2010
    }

    $flag = !$flag;
  }


// draw the inner circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset * 2) - 40, $diameter - ($inner_diameter_offset * 2) - 40, $white);  //13 Nov 2010

  imageellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset_2 * 2), $diameter - ($inner_diameter_offset_2 * 2), $black);
  imageellipse($im, $center_pt_x, $center_pt_y, $diameter - ($inner_diameter_offset_2 * 2) - 40, $diameter - ($inner_diameter_offset_2 * 2) - 40, $black);      //13 Nov 2010


// ------------------------------------------

//data for chart
  drawboldtext($im, 10, 0, 2, 10, $black, dirname(__FILE__) . '/arial.ttf', $line1, 0);
  drawboldtext($im, 10, 0, 2, 26, $black, dirname(__FILE__) . '/arial.ttf', $line2, 0);
  drawboldtext($im, 10, 0, 2, 42, $black, dirname(__FILE__) . '/arial.ttf', $line3, 0);
  drawboldtext($im, 10, 0, 2, 58, $black, dirname(__FILE__) . '/arial.ttf', $line4, 0);

  //drawboldtext($im, 11, 0, 490, 12, $black, dirname(__FILE__) . '/arial.ttf', $copyright1, 0);
  //drawboldtext($im, 11, 0, 490, 28, $black, dirname(__FILE__) . '/arial.ttf', $copyright2, 0);

  //imageline($im, 0, 64, $overall_size + $extra_width_for_aspect_grid, 64, $gray);   //border

// ------------------------------------------

//draw the horizontal line for the Ascendant
  $x1 = -($radius - $inner_diameter_offset) * cos(deg2rad(0));
  $y1 = -($radius - $inner_diameter_offset) * sin(deg2rad(0));

  $x2 = -$radius * cos(deg2rad(0));
  $y2 = -$radius * sin(deg2rad(0));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

//draw the arrow for the Ascendant
  $x1 = -$radius;
  $y1 = 30 * sin(deg2rad(0));

  $x2 = -($radius - 12);
  $y2 = 12 * sin(deg2rad(-15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $y2 = 12 * sin(deg2rad(15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------

// draw in the actual house cusp numbers and sign
  for ($i = 1; $i <= 12; $i = $i + 1)
  {
    $angle = -($Ascendant1 - $hc[$i]);

    $sign_pos = floor($hc[$i] / 30) + 1;
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    display_house_cusp($i, $angle, $middle_radius, $xy);            //sign glyph
    if ($ubt1 == 0) { imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($sign_glyph[$sign_pos])); }

    if ($i >= 1 And $i <= 6)
    {
      display_house_cusp($i, $angle - 5, $middle_radius, $xy);
    }
    else
    {
      display_house_cusp($i, $angle + 6, $middle_radius, $xy);
    }

    $reduced_pos = Reduce_below_30($hc[$i]);
    $int_reduced_pos = floor($reduced_pos);
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    if ($ubt1 == 0) { imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, dirname(__FILE__) . '/arial.ttf', $t . chr(176)); }

    // house cusp minute
    if ($i >= 1 And $i <= 4)
    {
      display_house_cusp($i, $angle + 5, $middle_radius, $xy);
    }
    elseif ($i == 5 Or $i == 6)
    {
      display_house_cusp($i, $angle + 6, $middle_radius, $xy);
    }
    elseif ($i == 7)
    {
      display_house_cusp($i, $angle - 5, $middle_radius, $xy);
    }
    else
    {
      display_house_cusp($i, $angle - 6, $middle_radius, $xy);
    }

    $reduced_pos = Reduce_below_30($hc[$i]);
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    if ($ubt1 == 0) { imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, dirname(__FILE__) . '/arial.ttf', $t . " " . chr(39)); }
  }

// ------------------------------------------

// draw the lines for the house cusps
  for ($i = 1; $i <= 12; $i = $i + 1)
  {
    $angle = $Ascendant1 - $hc[$i];
    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    $x2 = -($radius - $inner_diameter_offset) * cos(deg2rad($angle));
    $y2 = -($radius - $inner_diameter_offset) * sin(deg2rad($angle));

    if ($i != 1 And $i != 10)
    {
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $another_green);
    }

    // display the house numbers themselves - 26 March 2010
    $angle_diff = $hc[$i + 1] - $hc[$i];
    if ($angle_diff < -180) { $angle_diff = $angle_diff + 360; }

    $angle_to_use = $angle_sum + ($angle_diff / 2);

    //display_house_number_new($i, $angle_to_use, $radius - $inner_diameter_offset, $xy);
    display_house_number_new($i, $angle_to_use, $radius, $xy);

    // display the house numbers themselves
    if ($ubt1 == 0) { imagettftext($im, 11, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $another_green, dirname(__FILE__) . '/arial.ttf', $i); }

    $angle_sum = $angle_sum + $angle_diff;    //26 March 2010
  }

// ------------------------------------------

// draw the little degree marks around of the wheel
  $spoke_length = 9;
  $minor_spoke_length = 4;

  for ($i = 0; $i <= 359; $i = $i + 1)
  {
    $angle = $i + $Ascendant1;

    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    if ($i % 5 == 0)
    {
      $x2 = -($radius - $spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $red);
    }
    else
    {
      $x2 = -($radius - $minor_spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $minor_spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);
    }
  }

// ------------------------------------------

// draw the near-vertical line for the MC
  $angle = $Ascendant1 - $hc[10];
  $dist_mc_asc = $angle;

  if ($dist_mc_asc < 0)
  {
    $dist_mc_asc = $dist_mc_asc + 360;
  }

  $value = 90 - $dist_mc_asc;
  $angle1 = 65 - $value;
  $angle2 = 65 + $value;

  $x1 = -($radius - $inner_diameter_offset) * cos(deg2rad($angle));
  $y1 = -($radius - $inner_diameter_offset) * sin(deg2rad($angle));

  $x2 = -$radius * cos(deg2rad($angle));
  $y2 = -$radius * sin(deg2rad($angle));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// draw the arrow for the 10th house cusp (MC)
  $x1 = $x2 + (15 * cos(deg2rad($angle1)));
  $y1 = $y2 + (15 * sin(deg2rad($angle1)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $x1 = $x2 - (15 * cos(deg2rad($angle2)));
  $y1 = $y2 + (15 * sin(deg2rad($angle2)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------


// draw the dividing lines between the signs
  for ($i = 0; $i <= 330; $i = $i + 30)
  {
    //$angle = $Ascendant1 - $hc1[$i];
    $angle = $i + sprintf("%.0f", $Ascendant1);

    $x1 = -(150) * cos(deg2rad($angle));    //13 Nov 2010 - was 320
    $y1 = -(150) * sin(deg2rad($angle));

    $x2 = -(168) * cos(deg2rad($angle));    //13 Nov 2010 - was 300
    $y2 = -(168) * sin(deg2rad($angle));

    imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $red);
  }


// put signs around chartwheel
  $cw_sign_glyph = 14;
  $ch_sign_glyph = 12;
  $gap_sign_glyph = -44;

  for ($i = 1; $i <= 12; $i++)
  {
    $angle_to_use = deg2rad((($i - 1) * 30) + 15 - $Ascendant1);

    $center_pos_x = -$cw_sign_glyph / 2;
    $center_pos_y = $ch_sign_glyph / 2;

    $offset_pos_x = $center_pos_x * cos($angle_to_use);
    $offset_pos_y = $center_pos_y * sin($angle_to_use);

    $x1 = $center_pos_x + $offset_pos_x + ((-108 + $gap_sign_glyph) * cos($angle_to_use));    //13 Nov 2010 - was 260 instead of 108
    $y1 = $center_pos_y + $offset_pos_y + ((108 - $gap_sign_glyph) * sin($angle_to_use));

    if ($i == 1 Or $i == 5 Or $i == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($i == 2 Or $i == 6 Or $i == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($i == 3 Or $i == 7 Or $i == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($i == 4 Or $i == 8 Or $i == 12)
    {
      $clr_to_use = $blue;
    }

    drawboldtext($im, 10, 0, $x1 + $center_pt_x, $y1 + $center_pt_y, $clr_to_use, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($sign_glyph[$i]), 0); //used to be boldness of 1 - last number
  }

// ------------------------------------------

// put planets in chartwheel
  //sort longitudes in descending order from 360 down to 0
  Sort_planets_by_descending_longitude($num_planets, $longitude, $sort, $sort_pos);

  // count how many planets are in each house
  Count_planets_in_each_house($num_planets, $house_pos, $sort_pos, $sort, $nopih, $home);


  for ($i = 0; $i <= 359; $i++)
  {
    $spot_filled[$i] = 0;
  }

  $house_num = 0;

  // add planet glyphs around circle
  for ($i = $num_planets - 1; $i >= 0; $i--)
  {
    // $sort() holds longitudes in descending order from 360 down to 0
    // $sort_pos() holds the planet number corresponding to that longitude
    $temp = $house_num;
    $house_num = $house_pos[$sort_pos[$i]];              // get the house this planet is in

    if ($temp != $house_num)
    {
      // this planet is in a different house than the last one - this planet is the first one in this house, in other words
      $planets_done = 1;
    }

    // get index for this planet as to where it should be in the possible xx different positions around the wheel
    $from_cusp = Crunch($sort[$i] - $hc[$house_num]);
    $to_next_cusp = Crunch($hc[$house_num + 1] - $sort[$i]);
    $next_cusp = $hc[$house_num + 1];

    $angle = $sort[$i];
    $how_many_more_can_fit_in_this_house = floor($to_next_cusp / ($spacing + 1));

    if ($nopih[$house_num] - $planets_done >= $how_many_more_can_fit_in_this_house)
    {
      // problem - adjust this planet backwards so others can fit
      $angle = Crunch($next_cusp - (($nopih[$house_num] - $planets_done + 1) * ($spacing + 1)));
    }

    while (Check_for_overlap($angle, $spot_filled, $spacing) == True)
    {
      $angle = $angle + 1;
    }

    // mark this position as being filled
    $spot_filled[round($angle)] = 1;
    $spot_filled[Crunch(round($angle) - 1)] = 1;  // allows for a little better separation between Mars and Sun on 3/13/1966 test example

    // take the above index and convert it into an angle
    $planet_angle[$sort_pos[$i]] = $angle;              // needed for aspect lines
    $angle_to_use = Crunch($angle - $Ascendant1);       // needed for placing info on chartwheel
    $our_angle = $angle_to_use;                     // in degrees

    $angle_to_use = deg2rad($angle_to_use);

    // denote that we have done at least one planet in this house (actually count the planets in this house that we have done)
    $planets_done++;

    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1, $xy, 0);
    imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i]]));

    // display degrees of longitude for each planet
    $reduced_pos = Reduce_below_30($sort[$i]);
    $int_reduced_pos = floor($reduced_pos);
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 18, $xy, 1);
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, dirname(__FILE__) . '/arial.ttf', $t . chr(176));

    // display planet sign
    $sign_pos = floor($sort[$i] / 30) + 1;
    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 34, $xy, 2);
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));

    // display minutes of longitude for each planet
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }
    display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 52, $xy, 1);
    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, dirname(__FILE__) . '/arial.ttf', $t);

    // display Rx symbol
    if (strtoupper(mid($retrograde, $sort_pos[$i] + 1, 1)) == "R")
    {
      display_planet_glyph($our_angle, $angle_to_use, $radius - $dist_from_diameter1 - 65, $xy, 3);
      imagettftext($im, 8, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $red, dirname(__FILE__) . '/HamburgSymbols.ttf', chr(62));
    }
  }

// ------------------------------------------


// draw in the aspect lines
  for ($i = 0; $i <= $last_planet_num - 1; $i++)
  {
    for ($j = $i + 1; $j <= $last_planet_num; $j++)
    {
      if ($sort_pos[$i] == SE_CHIRON Or $sort_pos[$j] == SE_CHIRON) { continue; }
      if ($sort_pos[$i] == SE_TNODE Or $sort_pos[$j] == SE_TNODE) { continue; }

      $q = -99;
      $da = abs($longitude[$sort_pos[$i]] - $longitude[$sort_pos[$j]]);

      if ($da >= 180) { $da = 360 - $da; }

      //is there an aspect within orb?
      if ($sort_pos[$i] == SE_SUN Or $sort_pos[$i] == SE_MOON Or $sort_pos[$j] == SE_SUN Or $sort_pos[$j] == SE_MOON)
      {
        $orb = 8;
      }
      else
      {
        $orb = 6;
      }

      if ($da <= $orb)
      {
        $q = 1;
      }
      elseif ($da <= 60 + $orb And $da >= 60 - $orb)
      {
        $q = 6;
      }
      elseif ($da <= 90 + $orb And $da >= 90 - $orb)
      {
        $q = 4;
      }
      elseif ($da <= 120 + $orb And $da >= 120 - $orb)
      {
        $q = 3;
      }
      elseif ($da <= 153 And $da >= 147)
      {
        $q = 5;              //uses a 3-degreee orb
      }
      elseif ($da >= 180 - $orb)
      {
        $q = 2;
      }

      if ($q >= 0)
      {
        if ($q != 0)
        {
          //non-conjunctions
          $x1 = (-$radius + 111) * cos(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));      //13 Nov 2010 - the 111 was 91 previously, as per above
          $y1 = ($radius - 111) * sin(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          $x2 = (-$radius + 111) * cos(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          $y2 = ($radius - 111) * sin(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));

          //set image style
          $style = array($asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q], $asp_color_special[$q]);

          imagesetstyle($im, $style);
          imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, IMG_COLOR_STYLED);

          //draw in aspect glyph
          drawboldtext($im, 15, 0, (($x1 + $x2) / 2) - 7 + $center_pt_x, (($y1 + $y2) / 2) + 7 + $center_pt_y, $asp_color_special[$q], dirname(__FILE__) . '/HamburgSymbols.ttf', chr($asp_glyph[$q]), 0); //thicker
        }
      }
    }
  }


//insert the aspect grid here
  $y_offset = $y_top_margin + 650;
  $margins = 270;       //left and right margins on the background graphic

  $pl_name[LAST_PLANET + 1] = "Asc";
  $pl_name[LAST_PLANET + 2] = "MC";

  $cell_width = 20;
  $cell_height = 20;

  $last_planet_num = LAST_PLANET + 2;
  $num_planets = $last_planet_num + 1;


  $left_margin_planet_table = ($num_planets + 0.5) * $cell_width;

// ------------------------------------------

// draw the grid - horizontal lines
  $num_active_planets = 14;

  $cnt = 0;
  for ($i = 0; $i <= $last_planet_num - 1; $i++)
  {
    imageline($im, $margins, $cell_height * ($cnt + 1) + $y_offset, $margins + $cell_width * ($cnt + 1), $cell_height * ($cnt + 1) + $y_offset, $black);
    $cnt++;
  }

  imageline($im, $margins, $cell_height * $num_active_planets + $y_offset, $margins + $cell_width * $cnt, $cell_height * $num_active_planets + $y_offset, $black);


// draw the grid - vertical lines
  $cnt = 1;
  for ($i = 1; $i <= $last_planet_num; $i++)
  {
    imageline($im, $margins + $cell_width * $cnt, $cell_height * $num_active_planets + $y_offset, $margins + $cell_width * $cnt, $cell_height * $cnt + $y_offset, $black);
    $cnt++;
  }

  imageline($im, $margins, $cell_height * $num_active_planets + $y_offset, $margins, $cell_height + $y_offset, $black);

// ------------------------------------------

// draw in the planet glyphs
  $cnt = 0;
  $left_margin_planet_table = ($num_active_planets + 0.5) * $cell_width;

  for ($i = 0; $i <= $last_planet_num; $i++)
  {
    $s_pos = floor($longitude[$i] / 30) + 1;
    $color_to_use = $element_color[$s_pos % 4];

    drawboldtext($im, 13, 0, $margins + $cnt * $cell_width, $cell_height * ($cnt + 1) + $y_offset, $blue, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($pl_glyph[$i]), 0);

    if (strtoupper(mid($retrograde, $i + 1, 1)) == "R")
    {
      $txt = $pl_name[$i] . "  Rx";
      imagettftext($im, 8, 0, $margins + ($cnt + 1.25) * $cell_width, $cell_height * ($cnt + 1) - 3 + $y_offset, $another_green, dirname(__FILE__) . '/arial.ttf', $txt);
    }
    else
    {
      imagettftext($im, 8, 0, $margins + ($cnt + 1.25) * $cell_width, $cell_height * ($cnt + 1) - 3 + $y_offset, $another_green, dirname(__FILE__) . '/arial.ttf', $pl_name[$i]);
    }

    $cnt++;
  }

// ------------------------------------------

// display the aspect glyphs in the aspect grid
  $cnt_i = -1;

  for ($i = 0; $i <= $last_planet_num - 1; $i++)
  {
    $cnt_i++;
    $cnt_j = $cnt_i;

    for ($j = $i + 1; $j <= $last_planet_num; $j++)
    {
      $cnt_j++;

      $q = -99;
      $da = abs($longitude[$i] - $longitude[$j]);

      if ($da >= 180) { $da = 360 - $da; }

      //is there an aspect within orb?
      if ($i == SE_SUN Or $i == SE_MOON Or $j == SE_SUN Or $j == SE_MOON)
      {
        $orb = 8;
      }
      elseif ($i == SE_TNODE Or $j == SE_TNODE)
      {
        $orb = 3;
      }
      else
      {
        $orb = 6;
      }

      if ($da <= $orb)
      {
        $q = 1;
      }
      elseif ($da <= 60 + $orb And $da >= 60 - $orb)
      {
        $q = 6;
      }
      elseif ($da <= 90 + $orb And $da >= 90 - $orb)
      {
        $q = 4;
      }
      elseif ($da <= 120 + $orb And $da >= 120 - $orb)
      {
        $q = 3;
      }
      elseif ($da <= 153 And $da >= 147)
      {
        $q = 5;              //uses a 3-degreee orb
      }
      elseif ($da >= 180 - $orb)
      {
        $q = 2;
      }

      if ($q >= 0)
      {
        drawboldtext($im, 12, 0, $margins + $cell_width * ($cnt_i + 0.15), $cell_height * ($cnt_j + 1 - 0.20) + $y_offset, $asp_color_special[$q], dirname(__FILE__) . '/HamburgSymbols.ttf', chr($asp_glyph[$q]), 0);
      }
    }
  }


// ------------------------------------------


//start of planet listing
  $top_of_planet_listing = $y_top_margin + 20 + 650;
  $y_spacing = 20;
  $cnt = 0;

  for ($i = 0; $i <= $last_planet_num; $i++)
  {
    drawboldtext($im, 12, 0, 3, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($pl_glyph[$i]), 0);
    imagettftext($im, 8, 0, 25, $top_of_planet_listing + ($cnt * $y_spacing), $another_green, dirname(__FILE__) . '/arial.ttf', $pl_name[$i]);

    $sign_pos = floor($longitude[$i] / 30) + 1;
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    imagettftext($im, 10, 0, 85, $top_of_planet_listing + ($cnt * $y_spacing), $clr_to_use, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));

    // display planet data in the right-hand table
    $sign_num = floor($longitude[$i] / 30) + 1;
    imagettftext($im, 8, 0, 110, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', Convert_Longitude($longitude[$i]) . " " . $retrograde[$i]);

    //mark a planet's dignity, etc.
    if ($i == SE_SUN And $sign_pos == 5) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_SUN And $sign_pos == 1) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_SUN And $sign_pos == 11) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_SUN And $sign_pos == 7) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_MOON And $sign_pos == 4) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_MOON And $sign_pos == 2) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_MOON And $sign_pos == 10) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_MOON And $sign_pos == 8) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_MERCURY And $sign_pos == 3) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_MERCURY And $sign_pos == 6) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dig./Exalt."); }
    if ($i == SE_MERCURY And $sign_pos == 9) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_MERCURY And $sign_pos == 12) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detr./Fall"); }

    if ($i == SE_VENUS And ($sign_pos == 2 Or $sign_pos == 7)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_VENUS And $sign_pos == 12) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_VENUS And ($sign_pos == 8 Or $sign_pos == 1)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_VENUS And $sign_pos == 6) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_MARS And ($sign_pos == 1 Or $sign_pos == 8)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_MARS And $sign_pos == 10) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_MARS And ($sign_pos == 7 Or $sign_pos == 2)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_MARS And $sign_pos == 4) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_JUPITER And ($sign_pos == 9 Or $sign_pos == 12)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_JUPITER And $sign_pos == 4) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_JUPITER And ($sign_pos == 3 Or $sign_pos == 6)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_JUPITER And $sign_pos == 10) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_SATURN And ($sign_pos == 10 Or $sign_pos == 11)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_SATURN And $sign_pos == 7) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_SATURN And ($sign_pos == 4 Or $sign_pos == 5)) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_SATURN And $sign_pos == 1) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_URANUS And $sign_pos == 11) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_URANUS And $sign_pos == 8) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_URANUS And $sign_pos == 5) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_URANUS And $sign_pos == 2) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_NEPTUNE And $sign_pos == 12) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_NEPTUNE And $sign_pos == 4) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_NEPTUNE And $sign_pos == 6) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_NEPTUNE And $sign_pos == 10) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    if ($i == SE_PLUTO And $sign_pos == 8) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Dignified"); }
    if ($i == SE_PLUTO And $sign_pos == 5) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Exalted"); }
    if ($i == SE_PLUTO And $sign_pos == 2) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Detriment"); }
    if ($i == SE_PLUTO And $sign_pos == 11) { imagettftext($im, 10, 0, 200, $top_of_planet_listing + ($cnt * $y_spacing), $blue, dirname(__FILE__) . '/arial.ttf', "Fall"); }

    $cnt++;
  }


// ------------------------------------------


// start of feaw_cfm grid for displaying feaw and cfm planets
  $y_offset = $y_top_margin + 600;
  $margins = 279;

  $cell_width = 25;
  $cell_height = 25;

// draw grid for element/modalities - horiz lines
  $em_cell_width = 70;
  $em_cell_height = 40;
  $cell_left_margin = 210;
  $cell_top_margin = 20;

  for ($i = 0; $i <= 4; $i++)
  {
    imageline($im, $margins + $cell_left_margin, $y_offset + $cell_top_margin + $em_cell_height * $i, $margins + $cell_left_margin + (3 * $em_cell_width), $y_offset + $cell_top_margin + $em_cell_height * $i, $black);
  }


// draw grid for element/modalities - vert lines
  for ($i = 0; $i <= 3; $i++)
  {
    imageline($im, $margins + $cell_left_margin + ($em_cell_width * $i), $y_offset + $cell_top_margin, $margins + $cell_left_margin + ($em_cell_width * $i), $y_offset + $cell_top_margin + $em_cell_height * 4, $black);
  }

  drawboldtext($im, 10, 0, $margins + $cell_left_margin - 16, $y_offset + 7 + (2 * $em_cell_height / 2), $red, dirname(__FILE__) . '/arial.ttf', "F", 0);
  drawboldtext($im, 10, 0, $margins + $cell_left_margin - 16, $y_offset + 7 + (4 * $em_cell_height / 2), $another_green, dirname(__FILE__) . '/arial.ttf', "E", 0);
  drawboldtext($im, 10, 0, $margins + $cell_left_margin - 16, $y_offset + 7 + (6 * $em_cell_height / 2), $orange, dirname(__FILE__) . '/arial.ttf', "A", 0);
  drawboldtext($im, 10, 0, $margins + $cell_left_margin - 16, $y_offset + 7 + (8 * $em_cell_height / 2), $blue, dirname(__FILE__) . '/arial.ttf', "W", 0);

  drawboldtext($im, 10, 0, $margins + $cell_left_margin + 32, $y_offset + $cell_top_margin + 178, $black, dirname(__FILE__) . '/arial.ttf', "C                F                M", 0);


//fill the box with glyphs
  $row_col_idx = array();     //elements run 0 to 3 for row number, 0 to 2 for column number, and 0 - 7 for spot taken

  for ($i = 0; $i <= $num_planets; $i++)
  {
    $sign_num = floor($longitude[$i] / 30);
    $element_num = $sign_num % 3;
    $modal_num = $sign_num % 4;

    //find next open position in the $row_col_idx() array
    for ($j = 0; $j <= 7; $j++)
    {
      if ($row_col_idx[$element_num][$modal_num][$j] == 0)
      {
        $row_col_idx[$element_num][$modal_num][$j] = 1;
        break;
      }
    }

    if ($j <= 5)
    {
      //display glyph in proper spot in proper cell
      $x_pos = $margins + $cell_left_margin + 5 + ($em_cell_width * $element_num) + (14 * ($j % 4));

      if ($j <= 3)
      {
        $y_pos = $cell_top_margin + 5 + ($em_cell_height * $modal_num) + 12;
      }
      else
      {
        $y_pos = $cell_top_margin + 5 + 14 + ($em_cell_height * $modal_num) + 19;
      }

      if ($modal_num == 0)
      {
        $clr_to_use = $red;
      }
      elseif ($modal_num == 1)
      {
        $clr_to_use = $another_green;
      }
      elseif ($modal_num == 2)
      {
        $clr_to_use = $orange;
      }
      elseif ($modal_num == 3)
      {
        $clr_to_use = $blue;
      }

      drawboldtext($im, 14, 0, $x_pos , $y_offset + $y_pos, $clr_to_use, dirname(__FILE__) . '/HamburgSymbols.ttf', chr($pl_glyph[$i]), 0);
    }
  }


// ------------------------------------------


  // draw the image in png format - using imagepng() results in clearer text compared with imagejpeg()
  $chartwheel_filename = $_SESSION['chartwheel_filename'];

  imagepng($im, $chartwheel_filename);      //output image to a file

  imagedestroy($im);


Function Sort_planets_by_descending_longitude($num_planets, $longitude, &$sort, &$sort_pos)
{
// load all $longitude() into sort() and keep track of the planet numbers in $sort_pos()
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $sort[$i] = $longitude[$i];
    $sort_pos[$i] = $i;
  }

// do the actual sort
  for ($i = 0; $i <= $num_planets - 2; $i++)
  {
    for ($j = $i + 1; $j <= $num_planets - 1; $j++)
    {
      if ($sort[$j] > $sort[$i])
      {
        $temp = $sort[$i];
        $temp1 = $sort_pos[$i];

        $sort[$i] = $sort[$j];
        $sort_pos[$i] = $sort_pos[$j];

        $sort[$j] = $temp;
        $sort_pos[$j] = $temp1;
      }
    }
  }
}


Function Count_planets_in_each_house($num_planets, $house_pos, &$sort_pos, &$sort, &$nopih, &$home)
{
// reset and count the number of planets in each house
  for ($i = 1; $i <= 12; $i++)
  {
    $nopih[$i] = 0;
  }

// run through all the planets and see how many planets are in each house
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $temp = $house_pos[$sort_pos[$i]];

    // get house planet is in
    $nopih[$temp]++;

    $home[$i] = $temp;
  }

  // now check for Aries planets in same house as Pisces planets that do not start a new house
  while ($home[$num_planets - 1] == $home[0])
  {
    $temp1 = $sort[$num_planets - 1];
    $temp2 = $sort_pos[$num_planets - 1];
    $temp3 = $home[$num_planets - 1];

    for ($i = $num_planets - 1; $i >= 1; $i--)
    {
      $sort[$i] = $sort[$i - 1];
      $sort_pos[$i] = $sort_pos[$i - 1];
      $home[$i] = $home[$i - 1];
    }

    $sort[0] = $temp1;
    $sort_pos[0] = $temp2;
    $home[0] = $temp3;
  }
}


Function display_house_number_new($num, $angle, $radii, &$xy)
{
  if ($num < 10)
  {
    $char_width = 10;
  }
  else
  {
    $char_width = 18;
  }
  $half_char_width = $char_width / 2;
  $char_height = 12;
  $half_char_height = $char_height / 2;
  $quarter_char_height = $char_height / 4;

//puts center of character right on circumference of imaginary circle
  $xpos0 = -$half_char_width;
  $ypos0 = $char_height;

  if ($num == 1)
  {
    $radii = $radii + 1;

    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 2)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 3)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 4;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 4)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 5)
  {
    $xpos0 = 3;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 6)
  {
    $radii = $radii + 5;

    $xpos0 = $half_char_width / 2;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 7)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 0;
    $y_adj = -sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 8)
  {
    $radii = $radii - 2;

    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 9)
  {
    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 10)
  {
    $xpos0 = -2;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 11)
  {
    $radii = $radii + 7;

    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 12)
  {
    $radii = $radii + 2;

    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width / 2;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle));
  }

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));;

  return ($xy);
}


Function drawboldtext($image, $size, $angle, $x_cord, $y_cord, $clr_to_use, $fontfile, $text, $boldness)
{
  $_x = array(1, 0, 1, 0, -1, -1, 1, 0, -1);
  $_y = array(0, -1, -1, 0, 0, -1, 1, 1, 1);

  for ($n = 0; $n <= $boldness; $n++)
  {
    ImageTTFText($image, $size, $angle, $x_cord+$_x[$n], $y_cord+$_y[$n], $clr_to_use, $fontfile, $text);
  }
}


Function display_planet_glyph($our_angle, $angle_to_use, $radii, &$xy, $code)
{
// $code = 0 for planet glyph, 1 for text, 2 for sign glyph, 3 for Rx symbol
// $our_angle in degree, $angle_to_use in radians
  $this_angle = Crunch($our_angle);

  if ($this_angle >= 1 And $this_angle <= 181)
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 15;
      $ch_pl_glyph = 15;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 12;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 12;
      $ch_pl_glyph = 10;
    }
    else
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 10;
    }
  }
  else
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 13;
      $ch_pl_glyph = 17;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 10;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 8;
    }
    else
    {
      $cw_pl_glyph = 6;
      $ch_pl_glyph = 10;
    }
  }

  $gap_pl_glyph = -8;

// take into account the width and height of the glyph, defined below
// get distance we need to shift the glyph so that the absolute middle of the glyph is the start point
  $center_pos_x = -$cw_pl_glyph / 2;
  $center_pos_y = $ch_pl_glyph / 2;

// get the offset we have to move the center point to in order to be properly placed
  $offset_pos_x = $center_pos_x * cos($angle_to_use);
  $offset_pos_y = $center_pos_y * sin($angle_to_use);

// now get the final X, Y coordinates
  $xy[0] = $center_pos_x + $offset_pos_x + ((-$radii + $gap_pl_glyph) * cos($angle_to_use));
  $xy[1] = $center_pos_y + $offset_pos_y + (($radii - $gap_pl_glyph) * sin($angle_to_use));

  return ($xy);
}


Function display_house_cusp($num, $angle, $radii, &$xy)
{
  $char_width = 18;
  $half_char_width = $char_width / 2;
  $char_height = 14;
  $half_char_height = $char_height / 2;

//puts center of character right on circumference of circle
  $xpos0 = -$half_char_width;
  $ypos0 = $half_char_height;

  $x_adj = -cos(deg2rad($angle));
  $y_adj = sin(deg2rad($angle));

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));

  return ($xy);
}


Function Crunch($x)
{
  if ($x >= 0)
  {
    $y = $x - floor($x / 360) * 360;
  }
  else
  {
    $y = 360 + ($x - ((1 + floor($x / 360)) * 360));
  }

  return $y;
}


Function Check_for_overlap($angle, $spot_filled, $spacing)
{
// spacing is really 1 more than we enter with, but we use assign $spacing = 1 less for easier math below
  $result = False;

  for ($i = $angle - $spacing; $i <= $angle + $spacing; $i++)
  {
    if ($spot_filled[Crunch(round($i))] == 1)
    {
      $result = True;
      break;
    }
  }

  return $result;
}

?>